<?php
require_once __DIR__ . '/lib/DataSource.php';
$database = new DataSource();
$userName = "joeltom";
$firstName = "Joel";
$lastName = "Thomas";
$rand = rand(1, 1000);

// To insert values into the database.
$sql = "INSERT INTO users (userName, password, firstName, lastName) VALUES (?, concat(?,?), ?, ?)";
$paramType = 'sssss';
$paramValue = array(
    $userName,
    $userName,
    $rand,
    $firstName,
    $lastName
);
$currentId = $database->insert($sql, $paramType, $paramValue);

// By using select query to fetch inserted row from the database and display it into the browser.
echo "<b>Row Inserted:</b><br/><br/>";
$sql = "SELECT * FROM users WHERE userId= ?";
$paramType = 'i';
$paramValue = array(
    $currentId
);
$result = $database->select($sql, $paramType, $paramValue);
print "<PRE>";
print_r($result);
print "</PRE>";

// To update data by using CONCAT() into the database.
$sql = "UPDATE users SET userName=CONCAT(userName, firstName, lastName) WHERE userId=?";
$paramType = 'i';
$paramValue = array(
    $currentId
);
$database->execute($sql, $paramType, $paramValue);

// By using select query to fetch updated data from the database and display it to the browser.
echo "<b>Row Updated:</b><br/><br/>";
$sql = "SELECT * FROM users WHERE userId=?";
$paramType = 'i';
$paramValue = array(
    $currentId
);
$result = $database->select($sql, $paramType, $paramValue);
print "<PRE>";
print_r($result);
print "</PRE>";

// By using CONCAT() and CONCAT_WS() to fetch data from the database and display it to the browser.
$sql = "SELECT CONCAT(firstName, lastName) AS fullName FROM users WHERE userId=?";
$paramType = 'i';
$paramValue = array(
    $currentId
);
$result = $database->select($sql, $paramType, $paramValue);
print "<PRE>";
print_r($result);
print "</PRE>";

$sql = "SELECT CONCAT_WS(' ', firstName, lastName) AS fullName FROM users WHERE userId=?";
$paramType = 'i';
$paramValue = array(
    $currentId
);
$result = $database->select($sql, $paramType, $paramValue);
print "<PRE>";
print_r($result);
print "</PRE>";
?>